Attribute VB_Name = "z_UIMessages"
' Messaging module
Option Private Module
Option Explicit

Public Enum MsgCode
 ' EM_COMBO_TAKEN = ERR_COMBO_TAKEN

 EM_RIBBON_NOT_REACHABLE = 1
 EM_SELECTION_EMPTY
 
 IM_MARKDOWN_COMPLETE
 IM_PARSE_MORPHO
 IM_NO_PARSER_DATA
 IM_TEST_FAILED
 IM_PARSED_DESCRIPTION
 IM_EXPORT_COMPLETE
 IM_TRANSFORM_COMPLETE
  
 ' QM_CONFIG_EDIT_CONFIRM
End Enum

Private g_UI As API_UserInteraction

Public Function UserInteraction() As API_UserInteraction
  If g_UI Is Nothing Then _
    Set g_UI = New API_UserInteraction
  Set UserInteraction = g_UI
End Function

Public Function SetUserInteraction(newUI As API_UserInteraction)
  Set g_UI = newUI
End Function

Public Function ProcessErrorMessages(expectedErrors As Scripting.Dictionary)
  If Err.Number = 0 Then _
    Exit Function
    
  Call Unload(CSE_ProgressBar)
  If Not expectedErrors.Exists(Err.Number) Then _
    Call Err.Raise(Err.Number)
  
  Call UserInteraction.ShowMessage(Err.Number, Err.Source)
End Function

Public Function UIShowMessage(theCode As MsgCode, ParamArray params() As Variant)
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Select Case theCode
  Case EM_RIBBON_NOT_REACHABLE
    Call MsgBox("     !" & vbNewLine & _
                ",    Word       ", vbExclamation)
  Case EM_SELECTION_EMPTY:        Call MsgBox("    ", vbExclamation)
      
  Case IM_MARKDOWN_COMPLETE:      Call MsgBox(Fmt(" : {1}", unwrapped), vbInformation)
  Case IM_PARSE_MORPHO:           Call MsgBox(Fmt(" : {1}", unwrapped), vbInformation)
  Case IM_NO_PARSER_DATA:         Call MsgBox(Fmt("  : {1}", unwrapped), vbInformation)
  Case IM_TEST_FAILED:            Call MsgBox(Fmt("    : {1}", unwrapped), vbInformation)
  Case IM_EXPORT_COMPLETE:        Call MsgBox(" ", vbInformation)
  Case IM_TRANSFORM_COMPLETE:     Call MsgBox(Fmt(" : {1}", unwrapped), vbInformation)
  
  Case IM_PARSED_DESCRIPTION:     Call MsgBox(Fmt(" : {1}" & vbNewLine & _
                                                  " : {2}" & vbNewLine & _
                                                  " " & vbNewLine & "{3}", unwrapped), vbInformation)
      
  Case Else: Call MsgBox("  ", vbCritical)
  End Select
End Function

Public Function UIAskQuestion(theCode As MsgCode, ParamArray params() As Variant) As Boolean
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Dim answer&: answer = vbNo
  Select Case theCode
 ' Case QM_CONFIG_EDIT_CONFIRM
 '   answer = MsgBox("!      .        " & _
  '    vbNewLine & "      ", vbYesNo + vbQuestion)
    
  Case Else
    Call MsgBox("Invalid message code", vbCritical)
  End Select
  UIAskQuestion = answer = vbYes
End Function
