Attribute VB_Name = "z_UIRibbon"
'      
Option Explicit

Global g_UIState As UIState

Public Function GetUIState() As UIState
  If g_UIState Is Nothing Then
    Set g_UIState = New UIState
    Call g_UIState.ribbon_.LoadFrom(RibbonTempFile)
'    Call UIUpdateConfigList
  End If
  Set GetUIState = g_UIState
  If g_UIState.ribbon_.Value Is Nothing Then _
    Call UserInteraction.ShowMessage(EM_RIBBON_NOT_REACHABLE)
End Function

Public Sub Parse_LoadRibbon(aRibbon As IRibbonUI)
  Set g_UIState = New UIState
  Call g_UIState.ribbon_.Init(aRibbon, RibbonTempFile)
  'Call UIUpdateConfigList
End Sub

Public Sub Parse_OnBtn(iControl As IRibbonControl)
  Call EnsureGlobalState
  Select Case iControl.ID
  Case "NextFragment":        Call RunNextFragment
  Case "PrevFragment":        Call RunPrevFragment
  Case "BrowseFile":          Call RunBrowseFile
  Case "MorphoParse":         Call RunMorphoParse
  Case "ContextInfo":         Call RunContextInfo
    
  Case "MarkWord":            Call RunMarkWord
  Case "MarkParagraph":       Call RunMarkParagraph
  
  Case "TransformSingle":     Call RunTransformSingle
  Case "TransformAll":        Call RunTransformAll
  
  Case "ExportAll":           Call RunExportAll
  Case "ExportRanges":          Call RunExportRanges
  
  Case "ViewHelp":            Call RunHelp
  End Select
End Sub

Public Function ParseUI_DetectorCount(iControl As IRibbonControl, ByRef nCount)
  nCount = TDetector.[_Last]
End Function

Public Function ParseUI_DetectorLabel(iControl As IRibbonControl, nIndex%, ByRef vLabel)
  vLabel = DetectorToStr(nIndex + 1)
End Function

Public Function ParseUI_DetectorGetSelectedIndex(iControl As IRibbonControl, ByRef nValue)
  Call EnsureGlobalState
  nValue = g_UIState.detector_ - 1
End Function

Public Function ParseUI_DetectorChange(iControl As IRibbonControl, sID$, nIndex As Variant)
  Call EnsureGlobalState
  g_UIState.detector_ = nIndex + 1
  ' Do any UI updates needed on entity switch
End Function

Public Function ParseUI_ParamText(iControl As IRibbonControl, ByRef vLabel)
  vLabel = GetUIState.detectionParam_
End Function

Public Function ParseUI_ParamChange(iControl As IRibbonControl, sParam$)
  Call EnsureGlobalState
  g_UIState.detectionParam_ = sParam
End Function

Public Function ParseUI_TransformText(iControl As IRibbonControl, ByRef vLabel)
  vLabel = GetUIState.transformParam_
End Function

Public Function ParseUI_TransformChange(iControl As IRibbonControl, sParam$)
  Call EnsureGlobalState
  g_UIState.transformParam_ = sParam
End Function

Public Function ParseUI_CategoryText(iControl As IRibbonControl, ByRef vLabel)
  vLabel = GetUIState.category_
End Function

Public Function ParseUI_CategoryChange(iControl As IRibbonControl, sParam$)
  Call EnsureGlobalState
  g_UIState.category_ = sParam
End Function

Public Function ParseUI_MarkupCount(iControl As IRibbonControl, ByRef nCount)
  nCount = TColor.[_Last]
End Function

Public Function ParseUI_MarkupLabel(iControl As IRibbonControl, nIndex%, ByRef vLabel)
  vLabel = ColorToStr(nIndex + 1)
End Function

Public Function ParseUI_MarkupGetSelectedIndex(iControl As IRibbonControl, ByRef nValue)
  Call EnsureGlobalState
  nValue = g_UIState.color_ - 1
End Function

Public Function ParseUI_MarkupChange(iControl As IRibbonControl, sID$, nIndex As Variant)
  Call EnsureGlobalState
  g_UIState.color_ = nIndex + 1
End Function

' =============
Private Function EnsureGlobalState() As Boolean
  EnsureGlobalState = Not GetUIState Is Nothing
End Function

Private Function RibbonTempFile() As String
  RibbonTempFile = Environ("TEMP") & "/" & TEMP_FILE_NAME & CStr(GetCurrentProcessId) & ".txt"
End Function
