Attribute VB_Name = "DevHelper"
Option Explicit

Private Const TEST_BASIC_PARSE = "TestBasic.docx"
Private Const ADDIN_FILE = "Parsers.dotm"

Private g_RemoveAddin As Boolean

Public Function Dev_PrepareSkeleton()
  Call ClearAll
End Function

Public Sub Dev_ManualRunTest()
  Dim sSuite$: sSuite = "s_WordInteractions"
  Dim sTest$: sTest = "t_ImportDates"
  Dim sMsg$: sMsg = Dev_RunTestDebug(sSuite, sTest)
  Debug.Print sMsg
  Call MsgBox(sMsg)
End Sub

Public Function Dev_GetTestSuite(sName$) As Object
  Select Case sName
    Case "s_WordInteractions": Set Dev_GetTestSuite = New s_WordInteractions
  End Select
End Function

Public Function GetTestFile() As String
  Dim fso As New Scripting.FileSystemObject
  GetTestFile = ThisWorkbook.Path & "\test\" & TEST_BASIC_PARSE
End Function

Public Function SetupTestAddin()
  Dim fso As New Scripting.FileSystemObject
  Dim sLocal$: sLocal = ThisWorkbook.Path & "\\" & ADDIN_FILE
  Dim sAppAddin$: sAppAddin = GetGlobalAddin
  g_RemoveAddin = Not fso.FileExists(sAppAddin)
  Call CopyFileOrFolder(sLocal, sAppAddin, fso)
End Function

Public Function TeardownTestAddin()
  Dim fso As New Scripting.FileSystemObject
  On Error Resume Next
  If g_RemoveAddin Then _
    Call fso.DeleteFile(GetGlobalAddin)
End Function

' ======
Private Function GetGlobalAddin() As String
  GetGlobalAddin = VBA.Environ$("APPDATA") & "\Microsoft\Word\STARTUP\" & ADDIN_FILE
End Function
