VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} ImportDlg 
   Caption         =   "  "
   ClientHeight    =   2805
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   6780
   OleObjectBlob   =   "ImportDlg.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "ImportDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public isCancelled_ As Boolean
Public isFolder_ As Boolean

Private Sub UserForm_Initialize()
  Dim nType As TDetector
  For nType = TDetector.[_First] To TDetector.[_Last]
    Call CBType.AddItem(DetectorToStr(nType))
  Next nType
  
  isFolder_ = False
  isCancelled_ = True
  TBCategory.Value = 0
End Sub

Private Sub UserForm_Terminate()
  isCancelled_ = True
  Call Me.Hide
End Sub

Public Property Get FileName() As String
  FileName = TBDocument.Text
End Property

Public Property Get Options() As ExtractionOptions
  Set Options = New ExtractionOptions
  Options.detector_ = CBType.ListIndex + 1
  Options.param_ = TBParam.Text
  Options.transform_ = TBTransform.Text
  Options.loadCategory_ = TBCategory.Value
End Property

' ============
Private Sub DocumentBtn_Click()
  Dim sFile$: sFile = UserInteraction.PromptFileFilter( _
                                        ThisWorkbook.Path & "\", _
                                        sDescription:=" Word", _
                                        sFilter:="*.docx;*.doc;*.docm")
  If sFile = vbNullString Then _
    Exit Sub
  isFolder_ = False
  TBDocument.Text = sFile
End Sub

Private Sub ParameterBtn_Click()
Dim sFile$: sFile = UserInteraction.PromptFileFilter( _
                                    ThisWorkbook.Path & "\", _
                                    "All files", _
                                    "*.*")
  If sFile = vbNullString Then _
    Exit Sub
  TBParam.Text = sFile
End Sub

Private Sub FolderBtn_Click()
  Dim sFile$: sFile = UserInteraction.PromptFolder(ThisWorkbook.Path & "\")
  If sFile = vbNullString Then _
    Exit Sub
  isFolder_ = True
  TBDocument.Text = sFile
End Sub

Private Sub CancelBtn_Click()
  isCancelled_ = True
  Call Me.Hide
End Sub

Private Sub OkBtn_Click()
  If FileName = vbNullString Or CBType.ListIndex = -1 Then
    Call UserInteraction.ShowMessage(EM_VALIDATION_FAIL)
    Exit Sub
  End If
  
  isCancelled_ = False
  Call Me.Hide
End Sub
