Attribute VB_Name = "Main"
Option Explicit
Option Private Module

Public Const PRODUCT_VERSION = "1.3.0"
Public Const PRODUCT_NAME = "Concept-Mining"

Public g_VersionTimer As Long

Public Sub Auto_Open()
  Dim sCmd$: sCmd = OfficeCommandLine
  If VBA.InStr(1, sCmd, "/automation", vbTextCompare) <> 0 Then _
    Exit Sub
  
  g_VersionTimer = SetTimer(0, 0, CP_VERSION_MSG_DELAY, AddressOf OnVersionCheck)
End Sub

Public Function OnVersionCheck(ByVal nHwnd As Long, ByVal uMsg As Long, ByVal nEvent As Long, ByVal nTime As Long)
  Call KillTimer(0, g_VersionTimer)
  Call VersionValidate(PRODUCT_NAME, PRODUCT_VERSION)
End Function

Public Sub RunImportWord()
  If Not EnsureAddinInstalled Then _
    Exit Sub
    
  Call ImportDlg.Show
  If ImportDlg.isCancelled_ Then
    Unload ImportDlg
    Exit Sub
  End If
  
  Dim iParams As ExtractionOptions: Set iParams = ImportDlg.Options
  Dim sPath$: sPath = ImportDlg.FileName
  Dim bIsFolder As Boolean: bIsFolder = ImportDlg.isFolder_
  Call Unload(ImportDlg)
  
  Dim nCount&: nCount = ProcessImports(sPath, bIsFolder, iParams)
  
  Call UserInteraction.ShowMessage(IM_IMPORT_COMPLETE, nCount)
End Sub

Public Sub RunFollowLink()
  Dim theSheet As Excel.Worksheet: Set theSheet = DataSheet
  If ThisWorkbook.ActiveSheet.Name <> theSheet.Name Then
    Call UserInteraction.ShowMessage(EM_EXPECTED_DATASHEET)
    Exit Sub
  End If
  
  Dim nRow&: nRow = ThisWorkbook.Application.Selection.Cells(1, 1).Row
  Dim srcID$: srcID = theSheet.Cells(nRow, DS_ID)
  If srcID = vbNullString Or Not IsNumeric(srcID) Then
    Call UserInteraction.ShowMessage(EM_INVALID_SOURCE_ID)
    Exit Sub
  End If
  Call FollowLinkAt(CLng(srcID), theSheet.Cells(nRow, DS_START), theSheet.Cells(nRow, DS_END))
End Sub

Public Sub RunClearAll()
  Call ClearAll
  Call UserInteraction.ShowMessage(IM_CLEAR_ALL)
End Sub
