Attribute VB_Name = "z_UIMessages"
' Messaging module
Option Private Module
Option Explicit

Public Enum MsgCode
  MSG_OK = 0
  
  EM_EXPECTED_DATASHEET
  EM_NO_ADDIN
  EM_INVALID_SOURCE_ID
  EM_INVALID_PATH
  EM_INVALID_LINK
  EM_VALIDATION_FAIL
  
  IM_IMPORT_COMPLETE
  IM_CLEAR_ALL
  
  'QM_ADD_TITLELINK
End Enum

Private g_UI As API_UserInteraction

Public Function UserInteraction() As API_UserInteraction
  If g_UI Is Nothing Then _
    Set g_UI = New API_UserInteraction
  Set UserInteraction = g_UI
End Function

Public Function SetUserInteraction(newUI As API_UserInteraction)
  Set g_UI = newUI
End Function

Public Function UIShowMessage(theCode As MsgCode, ParamArray params() As Variant)
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Select Case theCode
  Case EM_EXPECTED_DATASHEET:   Call MsgBox("      """"", vbExclamation)
  Case EM_NO_ADDIN:             Call MsgBox("!         Word", vbCritical)
  Case EM_INVALID_SOURCE_ID:    Call MsgBox("     ", vbExclamation)
  Case EM_INVALID_PATH:         Call MsgBox(Fmt("  z: {1}", unwrapped), vbExclamation)
  Case EM_INVALID_LINK:         Call MsgBox(Fmt("   ,     {1}", unwrapped), vbExclamation)
  Case EM_VALIDATION_FAIL:      Call MsgBox("  ", vbExclamation)
    
  Case IM_IMPORT_COMPLETE:      Call MsgBox(Fmt("   " & vbNewLine & " : {1}", unwrapped), vbInformation)
  Case IM_CLEAR_ALL:            Call MsgBox("  ", vbInformation)
    
  Case Else
    Call MsgBox("  ", vbCritical)
  End Select
End Function

Public Function UIAskQuestion(theCode As MsgCode, ParamArray params() As Variant) As Boolean
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Dim answer As Long: answer = vbNo
  Select Case theCode
 ' Case QM_ADD_TITLELINK
 '   answer = MsgBox("!      " & vbNewLine & _
 '         "   ID: " & p1 & vbNewLine & _
 '         "      . ?", vbYesNo + vbQuestion)
    
  Case Else
    Call MsgBox("  ", vbCritical)
  End Select
  UIAskQuestion = answer = vbYes
End Function
