VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "s_WordInteractions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function Setup()
  Call SetupTestAddin
End Function

Public Function Teardown()
  Call TeardownTestAddin
  Call ClearAll
End Function

Public Function t_ImportInvalid()
  On Error GoTo PROPAGATE_ERROR
  
  Dim iParams As New ExtractionOptions
  iParams.detector_ = T_DETECTOR_DATE
  
  Call Dev_NewCase("No file")
  Call Dev_ExpectEQ(ProcessImports("invalid.txt", False, iParams, bSilent:=True), 0)
  Call Dev_ExpectEQ(SourceSheet.Cells(2, 1), "")
  
  Call Dev_NewCase("Invalid detector")
  iParams.detector_ = T_DETECTOR_UNKNOWN
  Call Dev_ExpectEQ(ProcessImports(GetTestFile, False, iParams, bSilent:=True), 0)
  
  Call Dev_NewCase("Invalid parameter")
  iParams.detector_ = T_DETECTOR_LIST
  iParams.param_ = "invalid.txt"
  Call Dev_ExpectEQ(ProcessImports(GetTestFile, False, iParams, bSilent:=True), 0)

  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function

Public Function t_ImportDates()
  On Error GoTo PROPAGATE_ERROR

  Dim iParams As New ExtractionOptions
  iParams.detector_ = T_DETECTOR_DATE
  Call Dev_ExpectEQ(ProcessImports(GetTestFile, False, iParams, bSilent:=True), 4)
  Call Dev_ExpectNE(SourceSheet.Cells(2, 1), "")

  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function
